//+------------------------------------------------------------------+
//|                                                        FONTS.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
input color backdrop_clr=clrDarkSlateGray;
input color code_clr=clrGold;
input color font_clr=clrWhiteSmoke;
input color button_clr=clrMidnightBlue;
input int x_dist=10;
input int y_dist=15;
extern string font_edit="Terminal";
bool button_1=true;
bool start=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+--------------;----------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   EventSetTimer(1);
//---
   return(INIT_SUCCEEDED);
  }
//==================================================================
void OnDeinit(const int reason)
  {
   f_Delete();
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
   char code=32;
   int u=32;
   ObjectGetString(0,"Panel_1",OBJPROP_TEXT,0,font_edit);
   if(button_1 && start)
     {
     start=false;
      RectLabelCreate("LabelCreate",x_dist,y_dist,970,400,backdrop_clr,backdrop_clr);
      
      for(int t=1;t<=7;t++)
        {
         for(int r=0;r<=31;r++)
           {

            f_Label("text_"+(string)r+(string)t,x_dist+12+30*r,y_dist+17+50*t,CharToStr(code),15,font_clr,font_edit);
            f_Label("numb_"+(string)r+(string)t,x_dist+12+30*r,y_dist+50*t,(string)u,8,code_clr);
            code++; u++;
           }
        }
         if(ObjectFind("butt_1")!=-1) ObjectDelete("butt_1");
         ButtonCreate("butt_2",x_dist+25,y_dist+5,120,20,"Wingdings",9,font_clr,button_clr,false);
         ButtonCreate("butt_3",x_dist+148,y_dist+5,120,20,"Wingdings 2",9,font_clr,button_clr,false);
         ButtonCreate("butt_4",x_dist+271,y_dist+5,120,20,"Wingdings 3",9,font_clr,button_clr,false);
         ButtonCreate("butt_5",x_dist+394,y_dist+5,120,20,"Arial",9,font_clr,button_clr,false);
         ButtonCreate("butt_6",x_dist+847,y_dist+5,120,20,"Enter",9,font_clr,button_clr,false);
         EditCreate("Panel_1",font_edit,x_dist+517,y_dist+5,327,20);
        }
      ButtonCreate("butt_1",x_dist+4,y_dist+5,20,20,CharToStr(84),16,font_clr,button_clr,false,"Wingdings 2");
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//-------------- "X"----------------------------------    
   if(sparam=="butt_1" && !button_1)
     {
      button_1=true;start=true; return;
     }
   if(sparam=="butt_1" && button_1)
     {
      button_1=false; f_Delete();start=true;
     }
//-------------- "Wingdings"----------------------------------    
   if(sparam=="butt_2")
     {
      font_edit="Wingdings"; f_Delete();start=true;
     }
//-------------- "Wingdings 2"----------------------------------    
   if(sparam=="butt_3")
     {
      font_edit="Wingdings 2"; f_Delete();start=true;
     }
//-------------- "Wingdings 3"----------------------------------    
   if(sparam=="butt_4")
     {
      font_edit="Wingdings 3"; f_Delete();start=true;
     }
//-------------- "Arial"----------------------------------    
   if(sparam=="butt_5")
     {
      font_edit="Arial"; f_Delete();start=true; 
     }
//-------------- "enter"----------------------------------    
   if(sparam=="butt_6")
     {
      f_Delete(); start=true;
     }
  }
//+------------------------------------------------------------------+
//    
//+------------------------------------------------------------------+ 
void f_Delete()
  {
   ObjectDelete("butt_1");
   ObjectDelete("butt_2");
   ObjectDelete("butt_3");
   ObjectDelete("butt_4");
   ObjectDelete("butt_5");
   ObjectDelete("butt_6");
   ObjectDelete("LabelCreate");
   ObjectDelete("Panel_1");
   for(int w=1;w<=7;w++)
     {
      for(int e=0;e<=31;e++)
        {
         ObjectDelete("text_"+(string)e+(string)w);
         ObjectDelete("numb_"+(string)e+(string)w);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool RectLabelCreate(
                     const string           name="RectLabel",          //                      
                     const int              x=0,                       //    X
                     const int              y=0,                       //    Y
                     const int              width=500,                 // 
                     const int              height=180,                // 
                     const color            back_clr=clrRed,           //                      
                     const color            clr=clrRed,                //    (Flat)
                     //---------------------------------------------------------------------------
                     const ENUM_LINE_STYLE  style=STYLE_SOLID,         //   
                     const int              line_width=1,              //   
                     const bool             back=false,                //   
                     const bool             selection=false,           //   
                     const bool             hidden=false,              //    
                     const long             chart_ID=0,                // ID 
                     const int              sub_window=0,              //  
                     const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER,  //    
                     const ENUM_BORDER_TYPE border_lab=BORDER_FLAT,    //  
                     const long             z_order=0)                 //    
  {
//---   
   ResetLastError();

   if(ObjectFind(name)==-1)
     {
      //---        
      ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border_lab);
      //---   ,      
      ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
      //---     (  Flat)
      ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
      //---     
      ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
      //---    
      ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width);
      //---    (false)   (true) 
      ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
      //---  (true)   (false)    
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
      //---  (true)   (false)      
      ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
      //---         
      ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
bool f_Label(
             const string            name="Label",             //                 
             const int               x=0,                      //    X
             const int               y=0,                      //    Y                 
             const string            text="error",             // 
             const int               font_size=10,             //                           
             const color             clr=clrRed,               // 
             //------------------------------------------------------
             const string            font="Arial",             //    
             const double            angle=0.0,                //  
             const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //  
             const bool              back=false,               //   
             const bool              selection=false,          //   
             const bool              hidden=true,              //    
             const long              chart_ID=0,               // ID 
             const int               sub_window=0,             //  
             const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
             const long              z_order=0)                //    
  {
//---   
   ResetLastError();
   if(ObjectFind(name)==-1)
     {
      //---   
      ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
      //---   ,      
      ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
      //---  
      // ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
      //---   
      ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
      //---    
      ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
      //---  
      ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
      //---    (false)   (true) 
      ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
      //---  (true)   (false)    
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
      //---  (true)   (false)      
      ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
      //---         
      ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
     }
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
   return(true);
  }
//=============================================================
bool ButtonCreate(const string  name="button",      //  
                  const int x=0,                    //    X
                  const int y=0,                    //    Y
                  const int width=0,                //  
                  const int height=0,               //  
                  const string text="error",        // 
                  const int font_size=6,            //  
                  const color clr=clrNONE,          //  
                  const color  back_clr=clrNONE,    //   
                  const bool state=false,           // /  
                  const string  font="Arial",       //                                                 
                  const color border_clr=clrNONE,   //    
                  //------------------------------------------------                               
                  const bool back=false,            //   
                  const bool selection=false,       //   
                  const bool hidden=false,          //    
                  const long z_order=0)             //    
  {
//---   
   ResetLastError();

   if(ObjectFind(name)==-1)
     {
      //---  
      ObjectCreate(0,name,OBJ_BUTTON,0,0,0);
      //---   
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      //---   
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      //---   ,      
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      //---  
      ObjectSetString(0,name,OBJPROP_TEXT,text);
      //---   
      ObjectSetString(0,name,OBJPROP_FONT,font);
      //---   
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,font_size);
      //---   
      ObjectSetInteger(0,name,OBJPROP_COLOR,clr);
      //---   
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,back_clr);
      //---   
      ObjectSetInteger(0,name,OBJPROP_BORDER_COLOR,border_clr);
      //---    (false)   (true) 
      ObjectSetInteger(0,name,OBJPROP_BACK,back);
      //---  (true)   (false)    
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,selection);
      ObjectSetInteger(0,name,OBJPROP_SELECTED,selection);
      //---  (true)   (false)      
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,hidden);
      //---         
      ObjectSetInteger(0,name,OBJPROP_ZORDER,z_order);
      //----- /
      ObjectSetInteger(0,name,OBJPROP_STATE,state);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|   " "                                      |
//+------------------------------------------------------------------+
bool EditCreate(
                const string           name="Edit",              //  
                const string           text="Arial",             //                
                const int              x=110,                    //    X
                const int              y=110,                    //    Y
                const int              width=90,                 // 
                const int              height=12,                // 
                //------------------------------------------------------------------
                const color            back_clr=clrDarkGray,     //  
                const color            border_clr=clrYellow,     //  
                const string           font="Arial",             // 
                const int              font_size=10,             //  
                const ENUM_ALIGN_MODE  align=ALIGN_CENTER,       //  
                const bool             read_only=false,          //  
                const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                const color            clr=clrBlack,             //                
                const bool             back=false,               //   
                const bool             selection=false,          //   
                const bool             hidden=false,             //    
                const long             z_order=0,                //    
                const long             chart_ID=0,               // ID 
                const int              sub_window=0              //  
                )
  {
//---   
   ResetLastError();
   if(ObjectFind(name)==-1)
     {
      //---   
      ObjectCreate(chart_ID,name,OBJ_EDIT,sub_window,0,0);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
      //---  
      //  ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
      //---   
      ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
      //---      
      ObjectSetInteger(chart_ID,name,OBJPROP_ALIGN,align);
      //---  (true)   (false)    
      ObjectSetInteger(chart_ID,name,OBJPROP_READONLY,read_only);
      //---   ,      
      ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
      //---   
      ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
      //---    (false)   (true) 
      ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
      //---  (true)   (false)    
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
      //---  (true)   (false)      
      ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
      //---         
      ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
     }
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
